configure 18.7 KB
Newer Older
ulrich_y's avatar
ulrich_y committed
1 2 3 4 5 6 7 8 9 10 11
#! /bin/bash
# configure script
# note: has nothing to do with GNU autoconf

exec 2> ${LOGFILE:-/dev/null} 3>&1
eval ${LOGFILE:+set -x}


shopt -s nullglob
export LC_ALL=C

ulrich_y's avatar
ulrich_y committed
12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70
printhelp() {
cat << EOF
\`configure' configures handyG to adapt to many kinds of systems.

Usage: ./configure [OPTION]... [VAR=VALUE]...

To assign environment variables (e.g., CC, CFLAGS...), specify them as
VAR=VALUE.  See below for descriptions of some of the useful variables.

Defaults for the options are specified in brackets.

Installation directories:
  --prefix=PREFIX         install files in PREFIX [/usr/]
  --mmprefix=PREFIX       install files in for Mathematica
                          [\$UserBaseDirectory/Kernel/]

By default, \`make install' will install all the files in
\`/usr/local/bin', \`/usr/local/lib' etc.  You can specify
an installation prefix other than \`/usr/local' using \`--prefix',
for instance \`--prefix=\$HOME'.

For better control, use the options below.
  --moduledir=DIR         Fortran module files (compiler specific)

Fine tuning of the installation directories:

System types:
  --32                    forces 32-bit compilation
  --64                    forces 64-bit compilation
  --generic               do not optimize code for the host machine

Optional Packages:
  --with-mcc              activates Mathematica interface
  --with-ginac            activates GiNaC interface for testing
  --debug                 compile with debug flags and without optimization

Some influential environment variables:
  FC          Fortran compiler command
  FFLAGS      Fortran compiler flags
  LD          linker command
  LDFLAGS     linker flags, e.g. -L<lib dir> if you have libraries in a
              nonstandard directory <lib dir>
  CC          C compiler command
  CFLAGS      C compiler flags
  CXX         C++ compiler command
  CXXFLAGS    C++ compiler flags
  FPATH       Path to put Fortran modules
  PKG_CONFIG_PATH
              directories to add to pkg-config's search path

Use these variables to override the choices made by \`configure' or to help
it to find libraries and programs with nonstandard names/locations.

Report bugs to <yannick.ulrich@psi.ch>.

EOF
exit
}

ulrich_y's avatar
ulrich_y committed
71 72
CONF_DIR="${0%/*}"
CONF_OS="`uname -s`"
ulrich_y's avatar
ulrich_y committed
73 74 75
HAVE_GINAC=false
HAVE_MCC=false
CONF_BITS=
ulrich_y's avatar
ulrich_y committed
76

ulrich_y's avatar
ulrich_y committed
77 78
CONF_FFLAGS=$FFLAGS
CONF_CFLAGS=$CFLAGS
ulrich_y's avatar
ulrich_y committed
79
CONF_CXXFLAGS=$CXXFLAGS
ulrich_y's avatar
ulrich_y committed
80 81 82 83 84
CONF_LFLAGS=$LDFLAGS
CONF_FC=$FC
CONF_CC=$CC
CONF_CXX=$CXX
CONF_LD=$LD
ulrich_y's avatar
ulrich_y committed
85
CONF_MODDIR=$FPATH
ulrich_y's avatar
ulrich_y committed
86 87


ulrich_y's avatar
ulrich_y committed
88 89 90 91 92 93
if [ "$CONF_OS" -eq "Darwin" ]; then
    CONF_PREFIX=/usr/local/
else
    CONF_PREFIX=/usr/
fi

ulrich_y's avatar
ulrich_y committed
94

ulrich_y's avatar
ulrich_y committed
95
allargs="$@"
ulrich_y's avatar
ulrich_y committed
96
NATIVE=true
ulrich_y's avatar
ulrich_y committed
97 98 99 100 101 102 103
DEBUG=false
for arg in "$@" ; do
    case "$arg" in
        --debug)
            DEBUG=true ;;
        --prefix=*)
            CONF_PREFIX="${arg#--prefix=}" ;;
ulrich_y's avatar
ulrich_y committed
104 105
        --moduledir=*)
            CONF_MODDIR="${arg#--moduledir=}" ;;
ulrich_y's avatar
ulrich_y committed
106
        --with-ginac)
ulrich_y's avatar
ulrich_y committed
107
            HAVE_GINAC=true ;;
ulrich_y's avatar
ulrich_y committed
108
        --with-mcc)
ulrich_y's avatar
ulrich_y committed
109
            HAVE_MCC=true ;;
ulrich_y's avatar
ulrich_y committed
110 111
        --mmprefix=*)
            CONF_MMPREFIX="${arg#--mmprefix=}" ;;
ulrich_y's avatar
ulrich_y committed
112 113
        --generic)
            NATIVE=false ;;
ulrich_y's avatar
ulrich_y committed
114 115 116 117
        --32)
            CONF_BITS="-m32" ;;
        --64)
            CONF_BITS="-m64" ;;
ulrich_y's avatar
ulrich_y committed
118 119
        --help )
            printhelp ;;
ulrich_y's avatar
ulrich_y committed
120
        -*)
ulrich_y's avatar
ulrich_y committed
121 122
            echo "Warning: $arg is not a valid option." 1>&3
            printhelp ;;
ulrich_y's avatar
ulrich_y committed
123 124 125
        *=*)
            eval "$arg" ;;
        *)
ulrich_y's avatar
ulrich_y committed
126 127
            echo "Warning: $arg is not a valid argument." 1>&3
            printhelp ;;
ulrich_y's avatar
ulrich_y committed
128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144
    esac
done


test=test$$
trap "rm -fr $test* =." 0 1 2 3 15


## look for some programs

findprog() {
    echo -n "looking for $1... " 1>&3
    var="$2"
    set -- ${!var:+"${!var}"} "${@:3}"
    for prog in "$@" ; do
        full="`type -P "$prog"`" && {
            echo "$full" 1>&3
ulrich_y's avatar
ulrich_y committed
145
            printf -v "CONF_$var" "%q" "$full"
ulrich_y's avatar
ulrich_y committed
146 147 148 149 150 151
            return 0
        }
    done
    echo "no $@ in your path" 1>&3
    return 1
}
ulrich_y's avatar
ulrich_y committed
152 153 154 155 156 157 158 159

findlib() {
    echo -n "looking for lib$1... " 1>&3
    for flag in $CONF_LFLAGS ; do
        case "$flag" in
            -L* )
                libfolder=${flag/-L/}
                if [ -f "$libfolder/lib$1.so" ] ; then
ulrich_y's avatar
ulrich_y committed
160
                    path=`readlink -f -- "$libfolder/lib$1.so"`
ulrich_y's avatar
ulrich_y committed
161
                    echo $path 1>&3
ulrich_y's avatar
ulrich_y committed
162
                    printf -v "CONF_$2" "%q" "$path"
ulrich_y's avatar
ulrich_y committed
163 164 165
                    return 0
                fi
                if [ -f "$libfolder/lib$1.a" ] ; then
ulrich_y's avatar
ulrich_y committed
166
                    path=`readlinf -f -- "$libfolder/lib$1.a"`
ulrich_y's avatar
ulrich_y committed
167
                    echo $path 1>&3
ulrich_y's avatar
ulrich_y committed
168
                    printf -v "CONF_$2" "%q" "$path"
ulrich_y's avatar
ulrich_y committed
169 170 171 172 173 174 175 176
                    return 0
                fi
            ;;
        esac
    done
    echo "not found" 1>&3
    return 1
}
ulrich_y's avatar
ulrich_y committed
177
addflag() {
ulrich_y's avatar
ulrich_y committed
178
    eval "CONF_$1=\"\${CONF_$1} ${@:2}\""
ulrich_y's avatar
ulrich_y committed
179 180 181 182 183
}

gnuflags() {
    eval addflag FFLAGS -fdefault-real-8             # default double is 8 byte
    eval addflag FFLAGS -cpp                         # C pre-processor
ulrich_y's avatar
ulrich_y committed
184
    eval addflag FFLAGS -pedantic-errors -std=f2008  # folow f08 strictly
ulrich_y's avatar
ulrich_y committed
185 186
    eval addflag FFLAGS -J build                     # where to put mods
    eval addflag FFLAGS -Werror -Wall                # make every warning an error
ulrich_y's avatar
ulrich_y committed
187
    eval addflag FFLAGS -Wno-uninitialized
ulrich_y's avatar
ulrich_y committed
188
    eval addflag FFLAGS -ffree-line-length-0
ulrich_y's avatar
ulrich_y committed
189 190
}

ulrich_y's avatar
ulrich_y committed
191

ulrich_y's avatar
ulrich_y committed
192 193 194
if [ -z $FC ]; then
    findprog fortran FC  ifort gfortran  || exit 1
fi
ulrich_y's avatar
ulrich_y committed
195 196


ulrich_y's avatar
ulrich_y committed
197
set -- `eval $CONF_FC --version -c | sed '/^$/d;s/([^)]*)//;q' 2>&1`
ulrich_y's avatar
ulrich_y committed
198 199
case "$1,$2,$3" in
    GNU,Fortran,[123].*)
200
        echo "Only version >= 4 are supported" 1>&3
ulrich_y's avatar
ulrich_y committed
201 202
        exit
    ;;
ulrich_y's avatar
ulrich_y committed
203
    GNU,Fortran,4.*)
204
    echo "Code optimisation is *not* suported on gfortran 4" 1>&3
ulrich_y's avatar
ulrich_y committed
205
        gnuflags
ulrich_y's avatar
ulrich_y committed
206
        eval addflag $CONF_BITS
ulrich_y's avatar
ulrich_y committed
207 208
        if $DEBUG ; then
            eval addflag FFLAGS -g -O0
ulrich_y's avatar
ulrich_y committed
209
            eval addflag FFLAGS -ffpe-trap=invalid,overflow
ulrich_y's avatar
ulrich_y committed
210 211 212 213 214
            eval addflag FFLAGS -fdump-core -fbacktrace
            eval addflag FFLAGS -frange-check
            eval addflag FFLAGS -DDEBUG
        else
            eval addflag FFLAGS -DRELEASE
ulrich_y's avatar
ulrich_y committed
215
            $NATIVE && eval addflag FFLAGS -march=native -mtune=native
ulrich_y's avatar
ulrich_y committed
216 217 218 219 220
        fi
    ;;
    GNU,Fortran,*)
        gnuflags
        eval addflag FFLAGS -Wno-maybe-uninitialized
ulrich_y's avatar
ulrich_y committed
221
        eval addflag $CONF_BITS
ulrich_y's avatar
ulrich_y committed
222 223
        if $DEBUG ; then
            eval addflag FFLAGS -g -O0
ulrich_y's avatar
ulrich_y committed
224
            eval addflag FFLAGS -ffpe-trap=invalid,overflow
ulrich_y's avatar
ulrich_y committed
225 226 227 228 229
            eval addflag FFLAGS -fdump-core -fbacktrace
            eval addflag FFLAGS -fcheck=all -frange-check
            eval addflag FFLAGS -DDEBUG
        else
            eval addflag FFLAGS -DRELEASE -O3
ulrich_y's avatar
ulrich_y committed
230
            $NATIVE && eval addflag FFLAGS -march=native -mtune=native
ulrich_y's avatar
ulrich_y committed
231 232 233 234 235 236 237
        fi
    ;;
    ifort*)
        eval addflag FFLAGS -autodouble
        eval addflag FFLAGS -module build
        eval addflag FFLAGS -fpp
        eval addflag FFLAGS -stand f03
ulrich_y's avatar
ulrich_y committed
238
        eval addflag $CONF_BITS
ulrich_y's avatar
ulrich_y committed
239 240 241 242
        if $DEBUG ; then
            eval addflag FFLAGS -g -O0
            eval addflag FFLAGS -DDEBUG
        else
ulrich_y's avatar
ulrich_y committed
243 244
            eval addflag FFLAGS -DRELEASE -O3 -fast
            $NATIVE && eval addflag FFLAGS -xHost
ulrich_y's avatar
ulrich_y committed
245
        fi
ulrich_y's avatar
ulrich_y committed
246
        if $HAVE_GINAC ; then
247
            echo "Option --with-ginac is incompatible with ifort, disabling" 1>&3
ulrich_y's avatar
ulrich_y committed
248
            HAVE_GINAC=false
ulrich_y's avatar
ulrich_y committed
249
        fi
ulrich_y's avatar
ulrich_y committed
250
        if $HAVE_MCC ; then
251
            echo "Option --with-mcc is incompatible with ifort, disabling" 1>&3
ulrich_y's avatar
ulrich_y committed
252
            HAVE_MCC=false
ulrich_y's avatar
ulrich_y committed
253 254 255
        fi
    ;;
    *)
256
        echo "Unknown compiler" 1>&3
ulrich_y's avatar
ulrich_y committed
257 258 259 260
        exit
    ;;
esac

ulrich_y's avatar
ulrich_y committed
261 262 263 264 265 266 267 268
echo -n "extracting the Fortran libraries... " 1>&3

rm -fr $test*

tee $test.f90 << _EOF_ 1>&2
    program test
    integer i
    common /uscore/ i
ulrich_y's avatar
ulrich_y committed
269
    call exit(i)
ulrich_y's avatar
ulrich_y committed
270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292
    end
_EOF_

while read line ; do
  set -- ${line//[:,()]/ }
  [[ "$1" =~ (/collect2|/ld|^ld)$ ]] && while test $# -gt 1 ; do
    shift
    case "$1" in
    *.o | -lc*)
      ;;
    -l* | -L* | *.a)
      FLDFLAGS+=" $1" ;;
    -Bstatic | -Bdynamic | *.ld)
      FLDFLAGS+=" -Wl,$1" ;;
    /*)
      FLDFLAGS+=" -L$1" ;;
    -rpath*)
      FLDFLAGS+=" -Wl,$1,$2"
      shift ;;
    -dynamic-linker)
      shift ;;
    esac
  done
ulrich_y's avatar
ulrich_y committed
293 294 295 296 297 298 299 300 301 302 303 304

  if [[ "$line" == *"-fintrinsic-modules-path"* ]]; then
    set -- ${line//[:,()]/ }
    while test $# -gt 1 ; do
      shift
      case "$1" in
        -fintrinsic-modules-path )
          CONF_MODPATH=$2
          ;;
      esac
    done
  fi
ulrich_y's avatar
ulrich_y committed
305
done < <(eval $CONF_FC  -v -o $test $test.f90 2>&1)
ulrich_y's avatar
ulrich_y committed
306 307
echo "ok" 1>&3

ulrich_y's avatar
ulrich_y committed
308
eval addflag LFLAGS "$LDFLAGS $CONF_LDFLAGS $FLDFLAGS -L$CONF_PREFIX/lib"
ulrich_y's avatar
ulrich_y committed
309

ulrich_y's avatar
ulrich_y committed
310 311
if [[ -z "$CONF_MODDIR" ]]; then
  if [[ ! -z "$CONF_MODPATH" ]]; then
ulrich_y's avatar
ulrich_y committed
312 313 314
    echo -n "checking whether module path is in prefix... " 1>&3
    if [[ "${CONF_MODPATH##$CONF_PREFIX}" != "${CONF_MODPATH}" ]]; then
        echo " yes" 1>&3
ulrich_y's avatar
ulrich_y committed
315
        CONF_MODDIR=$CONF_MODPATH
ulrich_y's avatar
ulrich_y committed
316 317
    else
        echo " no" 1>&3
ulrich_y's avatar
ulrich_y committed
318
        CONF_MODDIR=
ulrich_y's avatar
ulrich_y committed
319
    fi
ulrich_y's avatar
ulrich_y committed
320
  fi
ulrich_y's avatar
ulrich_y committed
321 322
fi

ulrich_y's avatar
ulrich_y committed
323

324
findprog pkg-config PKGCONFIG pkg-config
ulrich_y's avatar
ulrich_y committed
325
if [[ -z "$CONF_MODDIR" ]]; then
ulrich_y's avatar
ulrich_y committed
326
  if [[ -z "$CONF_PKGCONFIG" ]]; then
327 328 329 330 331 332 333 334 335
    echo "*************************************************" 1>&3
    echo "Warning! pkg-config not found! This may lead to  " 1>&3
    echo "difficulties when you try to compile your own    " 1>&3
    echo "code. You will need to run                       " 1>&3
    echo "                                                 " 1>&3
    echo "  $CONF_FC -I$CONF_PREFIX/include                " 1>&3
    echo "                                                 " 1>&3
    echo "every time.                                      " 1>&3
    echo "*************************************************" 1>&3
ulrich_y's avatar
ulrich_y committed
336
  fi
337
fi
ulrich_y's avatar
ulrich_y committed
338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354

if ( $HAVE_GINAC || $HAVE_MCC ); then
    findprog gcc CC clang gcc || exit 1
    findprog g++ CXX clang++ g++ || exit 1
    eval addflag CFLAGS "-std=c99"

    ## does Fortran append underscores to symbols?

    echo -n "does $CONF_FC append underscores... " 1>&3

    tee $test-c.c << _EOF_ 1>&2
int uscore_ = 95;
int uscore = 59;
_EOF_

    for CONF_BITS in ${CONF_BITS:--m64 -m32} ; do
      eval $CONF_CC $CONF_CFLAGS $CONF_BITS -c $test-c.c 1>&2 || continue
ulrich_y's avatar
ulrich_y committed
355
      eval $CONF_FC  -o $test $test.f90 $test-c.o 1>&2 && break
ulrich_y's avatar
ulrich_y committed
356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375
    done

    ./$test
    case $? in
    95)
      echo "yes" 1>&3
      CONF_NOUNDERSCORE=0 ;;
    59)
      echo "no" 1>&3
      CONF_NOUNDERSCORE=1 ;;
    *)
      echo "error linking Fortran and C" 1>&3
      exit 1 ;;
    esac

else
    $CONF_CC=
    $CONF_CXX=
    $CONF_CFLAGS=
    $CONF_NOUNDERSCORE=
ulrich_y's avatar
ulrich_y committed
376 377
fi

ulrich_y's avatar
ulrich_y committed
378 379 380

if $HAVE_MCC ; then
    PATH=$PATH:/Applications/Mathematica.app/Contents/MacOS/ findprog mathematica MATH math MathKernel math10 math11
ulrich_y's avatar
ulrich_y committed
381
    eval addflag FFLAGS -DHAVE_MM
ulrich_y's avatar
ulrich_y committed
382 383 384 385 386 387 388 389

    # Checking Mathematica system id

    echo -n "what is $CONF_MATH SystemID... " 1>&3

    tee $test.m << _EOF_ 1>&2
        Print["SYSID "<>ToString[\$SystemID]];
        Print["INSTDIR "<>ToString[\$InstallationDirectory]];
ulrich_y's avatar
ulrich_y committed
390
        Print["USERDIR "<>ToString[\$UserBaseDirectory]];
ulrich_y's avatar
ulrich_y committed
391 392 393 394
_EOF_
    $CONF_MATH < $test.m > $test.log
    CONF_MATH_SYS=`cat $test.log | grep "SYSID"   | sed 's/.*SYSID //'`
    CONF_MATH_DIR=`cat $test.log | grep "INSTDIR" | sed 's/.*INSTDIR //'`
ulrich_y's avatar
ulrich_y committed
395
    CONF_MATH_USR=`cat $test.log | grep "USERDIR" | sed 's/.*USERDIR //'`
ulrich_y's avatar
ulrich_y committed
396 397
    [[ -z "$CONF_MMPREFIX" ]] && \
       CONF_MMPREFIX=${CONF_MMPREFIX:=$CONF_MATH_USR/Kernel}
ulrich_y's avatar
ulrich_y committed
398 399 400 401 402 403 404 405 406 407 408 409 410 411 412
    echo  $CONF_MATH_SYS 1>&3


    # Finding mcc
    CONF_COMPAD=$CONF_MATH_DIR/SystemFiles/Links/MathLink/DeveloperKit/$CONF_MATH_SYS/CompilerAdditions/
    PATH=$CONF_COMPAD:$PATH findprog mcc MCC mcc

    echo -n "looking for MLDK directory... " 1>&3
    $CONF_MCC --internals > $test.int
    CONF_MLDK=`cat $test.int | grep "MLDK Directory" | cut -f2 -d":"`
    echo $CONF_MLDK 1>&3

    arch=`cat $test.int | grep "Library Bit Type:" | cut -f2 -d":"` ; \
    CONF_MCC_CFLAGS=`cat $test.int | grep "Compile Flags$arch:" | cut -f2 -d":"`
    CONF_MCC_LFLAGS=`cat $test.int | grep "Linker Libraries" | cut -f2 -d":"`
ulrich_y's avatar
ulrich_y committed
413
    CONF_MCC_LFLAGS="$CONF_LFLAGS $CONF_MCC_LFLAGS"
ulrich_y's avatar
ulrich_y committed
414 415 416 417 418 419 420 421
    cat $test.int | grep "Linker Libraries" | cut -f2 -d":"
    if [ ! -z $CONF_BITS ]; then
        if [ "$CONF_BITS" -ne "$MCC_BITS" ]; then
            echo "mcc wants $MCC_BITS ($arch), $CONF_BITS selected." 1>&3
            exit 1
        fi
    fi

ulrich_y's avatar
ulrich_y committed
422
    if [[ $CONF_MCC_LFLAGS == *"uuid"* ]]; then
ulrich_y's avatar
ulrich_y committed
423 424 425 426 427 428 429 430 431 432
        if ! findlib uuid UUID ; then
            echo -n "improvising uuid... " 1>&3
            CONF_MLIBDIR=$CONF_MATH_DIR/SystemFiles/Libraries/$CONF_MATH_SYS/
            if [ -f $CONF_MLIBDIR/libuuid.a ]; then
                CONF_MCC_LFLAGS="-L$CONF_MLIBDIR $CONF_MCC_LFLAGS"
                echo "okay" 1>&3
            else
                echo "failed" 1>&3
                exit 1
            fi
ulrich_y's avatar
ulrich_y committed
433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459 460 461 462 463 464 465 466 467 468
        fi
    fi

    # Finding MPREP
    PATH=$CONF_COMPAD:$PATH findprog mprep MPREP mprep

    ## can we do MathLink compilations
    echo -n "do we have working MathLink... " 1>&3
    tee $test.tm << _EOF_ 1>&2
:Begin:
:Function: test
:Pattern: Test[i_Integer]
:Arguments: {i}
:ArgumentTypes: {Integer}
:ReturnType: Integer
:End:

#include "mathlink.h"

static int test(const int i) {
  return i + 1;
}

int main(int argc, char **argv) {
  return MLMain(argc, argv);
}
_EOF_
    $CONF_MPREP $test.tm > $test.tm.c
    $CONF_CC $CONF_MCC_CFLAGS $CONF_CFLAGS -c $test.tm.c
    $CONF_CC -o $test.math $test.tm.o $CONF_MCC_LFLAGS
    test -x $test.math && {
        echo "yes" 1>&3
        CONF_ML=1
    } || {
        echo "no" 1>&3
        CONF_ML=0
ulrich_y's avatar
ulrich_y committed
469
        exit 1;
ulrich_y's avatar
ulrich_y committed
470 471
    }
fi
ulrich_y's avatar
ulrich_y committed
472 473


ulrich_y's avatar
ulrich_y committed
474
CONF_LD=${LD:-$CONF_FC}
ulrich_y's avatar
ulrich_y committed
475 476 477


if $HAVE_GINAC ; then
ulrich_y's avatar
ulrich_y committed
478
    eval addflag CXXFLAGS "-std=c++11"
ulrich_y's avatar
ulrich_y committed
479 480 481 482
    if [[ ! -z "$CONF_PKGCONFIG" ]]; then
        echo -n "Does pkg-config know about GiNaC... " 1>&3
        if $CONF_PKGCONFIG --exists ginac ; then
            echo "yes" 1>&3
ulrich_y's avatar
ulrich_y committed
483
            eval addflag CXXFLAGS `$CONF_PKGCONFIG --cflags ginac`
ulrich_y's avatar
ulrich_y committed
484 485
            eval addflag LFLAGS `$CONF_PKGCONFIG --libs ginac`
            FOUND_GINAC=true
ulrich_y's avatar
ulrich_y committed
486
            CONF_GINAC=`$CONF_PKGCONFIG --variable=libdir ginac`
ulrich_y's avatar
ulrich_y committed
487 488 489 490 491 492 493 494 495 496 497 498
        else
            echo "no" 1>&3
            FOUND_GINAC=false
        fi
    fi
    if ! $FOUNDGINAC ; then
        FOUNDGINAC=`findlib ginac GINAC && findlib cln CLN`
        eval addflag LFLAGS "-L`dirname $CONF_GINAC`"
        eval addflag LFLAGS "-L`dirname $CONF_CLN`"
        eval addflag LFLAGS "-lginac -lcln"
    fi
    if $FOUNDGINAC; then
ulrich_y's avatar
ulrich_y committed
499
        CONF_LD=${LD:-$CONF_CXX}
ulrich_y's avatar
ulrich_y committed
500 501 502 503 504 505 506 507 508 509 510 511 512 513 514
        echo -n "Checking if GiNaC works... " 1>&3
        tee $test.ginac.cpp << _EOF_ 1>&2
#include <ginac/ginac.h>
#include <iostream>
int main() {

    GiNaC::ex ans = GiNaC::G(0.3,0.5,0.7);
    ans -= 0.2876820724517808812+3.1415926535897932385*GiNaC::I;
    ans = GiNaC::abs(ans);
    if (ans<1e-15)
        return 0;
    else
        return 1;
}
_EOF_
ulrich_y's avatar
ulrich_y committed
515
        $CONF_CXX $CONF_CXXFLAGS $CONF_BITS -c $test.ginac.cpp
ulrich_y's avatar
ulrich_y committed
516 517 518 519 520 521 522 523 524 525 526 527 528 529 530 531 532 533 534 535
        $CONF_LD -o $test.ginac $test.ginac.o $CONF_LFLAGS
        ./$test.ginac
        case $? in
            0)
              echo "yes" 1>&3
              eval addflag FFLAGS "-DHAVE_GINAC" ;;
            1)
              echo "no" 1>&3
              exit 1 ;;
            *)
              echo "error running GiNaC" 1>&3
              exit 1 ;;
        esac
    else
        echo "GiNaC could not be found" 1>&3
        exit 1
    fi
fi


ulrich_y's avatar
ulrich_y committed
536 537 538
if $HAVE_GINAC && $HAVE_MCC; then
  eval addflag LFLAGS -lrt
fi
ulrich_y's avatar
ulrich_y committed
539

540 541 542 543 544 545 546 547 548 549 550
if [[ ! -z "$CONF_PKGCONFIG" ]]; then
cat > handyg.pc <<EOF
prefix=$CONF_PREFIX
exec_prefix=\${prefix}
libdir=\${exec_prefix}/lib
includedir=\${prefix}/include

Name: handyG
Description: Numerical evaluation of GPL
Version: 0.1.0
Libs: -L\${libdir} -lhandyg
ulrich_y's avatar
ulrich_y committed
551
Cflags: -I\${includedir} -fdefault-real-8
552 553 554 555
EOF

fi

ulrich_y's avatar
ulrich_y committed
556 557 558 559
echo "creating makefile" 1>&3


cat  > makefile <<EOF
ulrich_y's avatar
ulrich_y committed
560
# Generated through $0 $allargs on `date` by `whoami`
ulrich_y's avatar
ulrich_y committed
561 562 563 564 565 566 567

AR=ar rcs
FC=$CONF_FC
CC=$CONF_CC
CXX=$CONF_CXX
LD=$CONF_LD
MPREP=$CONF_MPREP
ulrich_y's avatar
ulrich_y committed
568
MATH=$CONF_MATH
ulrich_y's avatar
ulrich_y committed
569 570 571

FFLAGS=$CONF_FFLAGS
CFLAGS=$CONF_CFLAGS
ulrich_y's avatar
ulrich_y committed
572
CXXFLAGS=$CONF_CXXFLAGS
ulrich_y's avatar
ulrich_y committed
573 574 575 576
LFLAGS=$CONF_LFLAGS
MCFLAGS=$CONF_MCC_CFLAGS
MLFLAGS=$CONF_MCC_LFLAGS

ulrich_y's avatar
ulrich_y committed
577 578
PREFIX=$CONF_PREFIX
MMPREFIX=$CONF_MMPREFIX
ulrich_y's avatar
ulrich_y committed
579
MODDIR=$CONF_MODDIR
ulrich_y's avatar
ulrich_y committed
580

ulrich_y's avatar
ulrich_y committed
581

ulrich_y's avatar
ulrich_y committed
582
files=globals.o ieps.o utils.o shuffle.o maths_functions.o mpl_module.o gpl_module.o handyG.o
ulrich_y's avatar
ulrich_y committed
583 584 585
objects = \$(addprefix build/,\$(files))


ulrich_y's avatar
ulrich_y committed
586
all: libhandyg.a ${CONF_MPREP:+handyg} geval test
ulrich_y's avatar
ulrich_y committed
587

ulrich_y's avatar
ulrich_y committed
588
libhandyg.a:\$(objects)
ulrich_y's avatar
ulrich_y committed
589
		@echo "AR \$@"
ulrich_y's avatar
ulrich_y committed
590 591 592 593 594
		@\$(AR) \$@ \$^

handyg.mod: build/handyg.mod
		cp \$< \$@

ulrich_y's avatar
ulrich_y committed
595 596 597 598

# rules to make object files into /build
build/%.o: src/%.f90
		@echo "F90 \$@"
ulrich_y's avatar
ulrich_y committed
599
		@\$(FC) \$(FFLAGS) -c \$< -o \$@
ulrich_y's avatar
ulrich_y committed
600

ulrich_y's avatar
ulrich_y committed
601 602
build/%.o: checks/%.f90
		@echo "F90 \$@"
ulrich_y's avatar
ulrich_y committed
603
		@\$(FC) \$(FFLAGS) -c \$< -o \$@
ulrich_y's avatar
ulrich_y committed
604

ulrich_y's avatar
ulrich_y committed
605 606
build/%.o: src/%.cpp
		@echo "C++ \$@"
ulrich_y's avatar
ulrich_y committed
607
		@\$(CC) \$(CXXFLAGS) -c \$<  -o \$@
ulrich_y's avatar
ulrich_y committed
608

ulrich_y's avatar
ulrich_y committed
609
geval: libhandyg.a build/geval.o
ulrich_y's avatar
ulrich_y committed
610
		@echo "LD \$@"
ulrich_y's avatar
ulrich_y committed
611
		@\$(LD) -o \$@ build/geval.o -L. -lhandyg \$(LFLAGS)
ulrich_y's avatar
ulrich_y committed
612

ulrich_y's avatar
ulrich_y committed
613 614 615 616 617 618 619
EOF

$HAVE_MCC && cat >> makefile <<EOF
build/%.tm.c: src/%.tm
		@echo "MPREP \$@"
		@\$(MPREP) \$< -o \$@

ulrich_y's avatar
ulrich_y committed
620
build/mathlink.o: build/mathlink.tm.c
ulrich_y's avatar
ulrich_y committed
621 622 623
		@echo "CC \$<"
		@\$(CC) \$(MCFLAGS) \$(CFLAGS) -o \$@ -c \$<

ulrich_y's avatar
ulrich_y committed
624
handyg: build/mathlink.o libhandyg.a
ulrich_y's avatar
ulrich_y committed
625
		@echo "LD \$@"
ulrich_y's avatar
ulrich_y committed
626
		@\$(LD)  \$< libhandyg.a -o \$@ \$(LFLAGS) \$(MLFLAGS)
ulrich_y's avatar
ulrich_y committed
627

ulrich_y's avatar
ulrich_y committed
628 629 630
checks/test-chen.f90: checks/generate.m
		@echo "MATH generate \$@"
		@\$(MATH) -script \$< \$@
ulrich_y's avatar
ulrich_y committed
631
checks/test-chenff.f90: checks/generate.m
ulrich_y's avatar
ulrich_y committed
632 633
		@echo "MATH generate \$@"
		@\$(MATH) -script \$< \$@
ulrich_y's avatar
ulrich_y committed
634 635 636 637 638 639
checks/test-muone.f90: checks/generate.m
		@echo "MATH generate \$@"
		@\$(MATH) -script \$< \$@
checks/test-muoneNP.f90: checks/generate.m
		@echo "MATH generate \$@"
		@\$(MATH) -script \$< \$@
ulrich_y's avatar
ulrich_y committed
640 641


ulrich_y's avatar
ulrich_y committed
642 643 644 645 646 647
EOF
echo -n "test: \$(objects) " >> makefile

                            echo -n "build/test-chenref.o " >> makefile
$HAVE_GINAC              && echo -n "build/ginac.o " >> makefile
$HAVE_GINAC && $HAVE_MCC && echo -n "build/test-chen.o " >> makefile
ulrich_y's avatar
ulrich_y committed
648
$HAVE_GINAC && $HAVE_MCC && echo -n "build/test-chenff.o " >> makefile
ulrich_y's avatar
ulrich_y committed
649 650
$HAVE_GINAC && $HAVE_MCC && echo -n "build/test-muone.o " >> makefile
$HAVE_GINAC && $HAVE_MCC && echo -n "build/test-muoneNP.o " >> makefile
ulrich_y's avatar
ulrich_y committed
651

ulrich_y's avatar
ulrich_y committed
652 653
echo "build/test.o" >> makefile
cat  >> makefile <<EOF
ulrich_y's avatar
ulrich_y committed
654
		@echo "LD \$@"
ulrich_y's avatar
ulrich_y committed
655
		@\$(LD) -o \$@ \$^ \$(LFLAGS)
ulrich_y's avatar
ulrich_y committed
656

ulrich_y's avatar
ulrich_y committed
657
install: libhandyg.a handyg.mod ${CONF_MPREP:+handyg} geval
ulrich_y's avatar
ulrich_y committed
658
		mkdir -p \$(PREFIX)
ulrich_y's avatar
ulrich_y committed
659
		mkdir -p \$(PREFIX)/bin
ulrich_y's avatar
ulrich_y committed
660
		cp geval \$(PREFIX)/bin/geval
ulrich_y's avatar
ulrich_y committed
661
		mkdir -p \$(PREFIX)/lib
ulrich_y's avatar
ulrich_y committed
662
		cp libhandyg.a \$(PREFIX)/lib/
ulrich_y's avatar
ulrich_y committed
663
		mkdir -p \$(PREFIX)/include
ulrich_y's avatar
ulrich_y committed
664
		cp handyg.mod \$(PREFIX)/include/
ulrich_y's avatar
ulrich_y committed
665 666 667
EOF
$HAVE_MCC && cat >> makefile <<EOF
		mkdir -p \$(MMPREFIX)
ulrich_y's avatar
ulrich_y committed
668
		cp handyg \$(MMPREFIX)
ulrich_y's avatar
ulrich_y committed
669
EOF
670 671 672 673 674 675
if [[ ! -z "$CONF_PKGCONFIG" ]]; then
cat >> makefile <<EOF
		mkdir -p \$(PREFIX)/lib/pkgconfig
		cp handyg.pc \$(PREFIX)/lib/pkgconfig
EOF
fi
ulrich_y's avatar
ulrich_y committed
676
if [[ ! -z "$CONF_MODDIR" ]]; then
ulrich_y's avatar
ulrich_y committed
677
cat >> makefile <<EOF
ulrich_y's avatar
ulrich_y committed
678
		mkdir -p \$(MODDIR)
ulrich_y's avatar
ulrich_y committed
679
		cp handyg.mod \$(MODDIR)
ulrich_y's avatar
ulrich_y committed
680 681 682
EOF
fi

ulrich_y's avatar
ulrich_y committed
683 684 685

echo "uninstall:" >> makefile
echo -ne "\t\trm -i " >> makefile
ulrich_y's avatar
ulrich_y committed
686 687
echo -n "\$(PREFIX)/lib/libhandyg.a " >> makefile
echo -n "\$(PREFIX)/include/handyg.mod " >> makefile
ulrich_y's avatar
ulrich_y committed
688
echo -n "\$(PREFIX)/bin/geval " >> makefile
ulrich_y's avatar
ulrich_y committed
689
$HAVE_MCC && echo -n "\$(MMPREFIX)/handyg" >> makefile
690 691 692
if [[ ! -z "$CONF_PKGCONFIG" ]]; then
echo -n "\$(PREFIX)/lib/pkgconfig " >> makefile
fi
ulrich_y's avatar
ulrich_y committed
693 694
if [[ ! -z "$CONF_MODDIR" ]]; then
echo -n "\$(MODDIR)/handyg.mod " >> makefile
ulrich_y's avatar
ulrich_y committed
695
fi
ulrich_y's avatar
ulrich_y committed
696 697 698
cat  >> makefile <<EOF


ulrich_y's avatar
ulrich_y committed
699 700 701 702 703
check: test
		./$<

clean:
		@rm -f build/*.o build/*.mod build/*.c build/mcc.internals*
ulrich_y's avatar
ulrich_y committed
704
		@rm -f test geval libhandyg.a handyg
ulrich_y's avatar
ulrich_y committed
705
		@rm -f checks/test-chen.f90 checks/test-muone.f90 checks/test-muoneNP.f90
ulrich_y's avatar
ulrich_y committed
706 707 708

distclean:
		@rm -f build/*.o build/*.mod build/*.c build/mcc.internals*
ulrich_y's avatar
ulrich_y committed
709
		@rm -f test geval libhandyg.a handyg
ulrich_y's avatar
ulrich_y committed
710
		@rm -f checks/test-chen.f90 checks/test-muone.f90 checks/test-muoneNP.f90
711
		@rm -f makefile handyg.pc
ulrich_y's avatar
ulrich_y committed
712
EOF